/**
 * DevExtreme (cjs/ui/date_range_box/strategy/rangeCalendar.js)
 * Version: 23.1.1 (build 23114-0308)
 * Build date: Mon Apr 24 2023
 *
 * Copyright (c) 2012 - 2023 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.default = void 0;
var _renderer = _interopRequireDefault(require("../../../core/renderer"));
var _uiDate_boxStrategy = _interopRequireDefault(require("../../date_box/ui.date_box.strategy.calendar"));
var _extend = require("../../../core/utils/extend");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    _setPrototypeOf(subClass, superClass)
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}
var CALENDAR_RANGE_START_DATE_CLASS = "dx-calendar-range-start-date";
var CALENDAR_RANGE_END_DATE_CLASS = "dx-calendar-range-end-date";
var RangeCalendarStrategy = function(_CalendarStrategy) {
    _inheritsLoose(RangeCalendarStrategy, _CalendarStrategy);

    function RangeCalendarStrategy(dateBox) {
        var _this;
        _this = _CalendarStrategy.call(this) || this;
        _this.dateBox = dateBox;
        _this.dateRangeBox = dateBox.option("_dateRangeBoxInstance");
        return _this
    }
    var _proto = RangeCalendarStrategy.prototype;
    _proto.popupConfig = function(_popupConfig) {
        return (0, _extend.extend)(true, _CalendarStrategy.prototype.popupConfig.call(this, _popupConfig), {
            position: {
                of: this.dateRangeBox.$element()
            }
        })
    };
    _proto._getWidgetOptions = function() {
        return (0, _extend.extend)(_CalendarStrategy.prototype._getWidgetOptions.call(this), {
            values: this.dateRangeBox.option("value"),
            selectionMode: "range",
            viewsCount: 2,
            width: 260
        })
    };
    _proto.getValue = function() {
        return this._widget.option("values")
    };
    _proto._updateValue = function() {
        if (!this._widget) {
            return
        }
        this._widget.option("values", this.dateRangeBox.option("value"))
    };
    _proto._valueChangedHandler = function(_ref) {
        var value = _ref.value,
            previousValue = _ref.previousValue,
            event = _ref.event;
        this.tryUpdateValue(event, 0, value, previousValue);
        this.tryUpdateValue(event, 1, value, previousValue)
    };
    _proto.tryUpdateValue = function(event, index, value, previousValue) {
        if (this.getDateRangeBox()._isSameDates(value[index], previousValue[index])) {
            return
        }
        if ("instantly" === this.dateBox.option("applyValueMode")) {
            this.dateBoxValue(this.getValue()[index], event)
        }
    };
    _proto.dateBoxValue = function() {
        if (arguments.length) {
            return this.dateBox.dateValue.apply(this.dateBox, arguments)
        } else {
            return this.dateBox.dateOption.apply(this.dateBox, ["value"])
        }
    };
    _proto._cellClickHandler = function(_ref2) {
        var value = _ref2.value,
            event = _ref2.event;
        if ("instantly" === this.dateBox.option("applyValueMode")) {
            if (this.isStartDateSelected(event)) {
                this.setActiveStartDateBox();
                this.dateBoxValue(value, event);
                this.getDateRangeBox().getEndDateBox().focus();
                this.setActiveEndDateBox()
            } else {
                this.dateBoxValue(value, event);
                this.getDateRangeBox().close()
            }
        }
    };
    _proto.setActiveStartDateBox = function() {
        this.dateBox = this.dateRangeBox.getStartDateBox()
    };
    _proto.setActiveEndDateBox = function() {
        this.dateBox = this.dateRangeBox.getEndDateBox()
    };
    _proto.getDateRangeBox = function() {
        return this.dateRangeBox
    };
    _proto.isStartDateSelected = function(_ref3) {
        var currentTarget = _ref3.currentTarget;
        if ((0, _renderer.default)(currentTarget).hasClass(CALENDAR_RANGE_START_DATE_CLASS)) {
            return true
        }
        return false
    };
    _proto.isEndDateSelected = function(_ref4) {
        var currentTarget = _ref4.currentTarget;
        if ((0, _renderer.default)(currentTarget).hasClass(CALENDAR_RANGE_END_DATE_CLASS)) {
            return true
        }
        return false
    };
    return RangeCalendarStrategy
}(_uiDate_boxStrategy.default);
var _default = RangeCalendarStrategy;
exports.default = _default;
module.exports = exports.default;
module.exports.default = exports.default;
