/**
 * DevExtreme (cjs/ui/date_range_box/ui.date_range_box.js)
 * Version: 23.1.1 (build 23114-0308)
 * Build date: Mon Apr 24 2023
 *
 * Copyright (c) 2012 - 2023 Developer Express Inc. ALL RIGHTS RESERVED
 * Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
 */
"use strict";
exports.default = void 0;
var _renderer = _interopRequireDefault(require("../../core/renderer"));
var _component_registrator = _interopRequireDefault(require("../../core/component_registrator"));
var _extend = require("../../core/utils/extend");
var _icon = require("../../core/utils/icon");
var _config = _interopRequireDefault(require("../../core/config"));
var _message = _interopRequireDefault(require("../../localization/message"));
var _themes = require("../themes");
var _ui = _interopRequireDefault(require("../widget/ui.widget"));
var _ui2 = _interopRequireDefault(require("./ui.multiselect_date_box"));
var _index = _interopRequireDefault(require("../text_box/texteditor_button_collection/index"));
var _ui3 = _interopRequireDefault(require("../drop_down_editor/ui.drop_down_button"));
var _uiText_editor = _interopRequireDefault(require("../text_box/ui.text_editor.clear"));
var _function_template = require("../../core/templates/function_template");
var _date_serialization = _interopRequireDefault(require("../../core/utils/date_serialization"));
var _date = _interopRequireDefault(require("../../core/utils/date"));
var _element = require("../../core/element");

function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    }
}

function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest()
}

function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.")
}

function _unsupportedIterableToArray(o, minLen) {
    if (!o) {
        return
    }
    if ("string" === typeof o) {
        return _arrayLikeToArray(o, minLen)
    }
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if ("Object" === n && o.constructor) {
        n = o.constructor.name
    }
    if ("Map" === n || "Set" === n) {
        return Array.from(o)
    }
    if ("Arguments" === n || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) {
        return _arrayLikeToArray(o, minLen)
    }
}

function _arrayLikeToArray(arr, len) {
    if (null == len || len > arr.length) {
        len = arr.length
    }
    for (var i = 0, arr2 = new Array(len); i < len; i++) {
        arr2[i] = arr[i]
    }
    return arr2
}

function _iterableToArrayLimit(arr, i) {
    var _i = null == arr ? null : "undefined" != typeof Symbol && arr[Symbol.iterator] || arr["@@iterator"];
    if (null != _i) {
        var _s, _e, _x, _r, _arr = [],
            _n = !0,
            _d = !1;
        try {
            if (_x = (_i = _i.call(arr)).next, 0 === i) {
                if (Object(_i) !== _i) {
                    return
                }
                _n = !1
            } else {
                for (; !(_n = (_s = _x.call(_i)).done) && (_arr.push(_s.value), _arr.length !== i); _n = !0) {}
            }
        } catch (err) {
            _d = !0, _e = err
        } finally {
            try {
                if (!_n && null != _i.return && (_r = _i.return(), Object(_r) !== _r)) {
                    return
                }
            } finally {
                if (_d) {
                    throw _e
                }
            }
        }
        return _arr
    }
}

function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) {
        return arr
    }
}

function _extends() {
    _extends = Object.assign ? Object.assign.bind() : function(target) {
        for (var i = 1; i < arguments.length; i++) {
            var source = arguments[i];
            for (var key in source) {
                if (Object.prototype.hasOwnProperty.call(source, key)) {
                    target[key] = source[key]
                }
            }
        }
        return target
    };
    return _extends.apply(this, arguments)
}

function _inheritsLoose(subClass, superClass) {
    subClass.prototype = Object.create(superClass.prototype);
    subClass.prototype.constructor = subClass;
    _setPrototypeOf(subClass, superClass)
}

function _setPrototypeOf(o, p) {
    _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(o, p) {
        o.__proto__ = p;
        return o
    };
    return _setPrototypeOf(o, p)
}
var DATERANGEBOX_CLASS = "dx-daterangebox";
var START_DATEBOX_CLASS = "dx-start-datebox";
var END_DATEBOX_CLASS = "dx-end-datebox";
var DATERANGEBOX_SEPARATOR_CLASS = "dx-daterangebox-separator";
var DROP_DOWN_EDITOR_BUTTON_ICON = "dx-dropdowneditor-icon";
var TEXTEDITOR_INPUT_CLASS = "dx-texteditor-input";
var ALLOWED_STYLING_MODES = ["outlined", "filled", "underlined"];
var SEPARATOR_ICON_NAME = "to";
var DateRangeBox = function(_Widget) {
    _inheritsLoose(DateRangeBox, _Widget);

    function DateRangeBox() {
        return _Widget.apply(this, arguments) || this
    }
    var _proto = DateRangeBox.prototype;
    _proto._getDefaultOptions = function() {
        return (0, _extend.extend)(_Widget.prototype._getDefaultOptions.call(this), {
            acceptCustomValue: true,
            activeStateEnabled: true,
            applyButtonText: _message.default.format("OK"),
            applyValueMode: "instantly",
            buttons: void 0,
            calendarOptions: {},
            cancelButtonText: _message.default.format("Cancel"),
            dateOutOfRangeMessage: _message.default.format("validation-range"),
            dateSerializationFormat: void 0,
            disabledDates: null,
            displayFormat: null,
            dropDownOptions: {},
            dropDownButtonTemplate: "dropDownButton",
            endDate: null,
            focusStateEnabled: true,
            hoverStateEnabled: true,
            invalidDateMessage: _message.default.format("dxDateBox-validation-datetime"),
            isValid: true,
            startDateLabel: "Start Date",
            endDateLabel: "End Date",
            startDatePlaceholder: "",
            endDatePlaceholder: "",
            labelMode: "static",
            max: void 0,
            maxLength: null,
            min: void 0,
            opened: false,
            openOnFieldClick: false,
            readOnly: false,
            showClearButton: false,
            showDropDownButton: true,
            spellcheck: false,
            startDate: null,
            stylingMode: (0, _config.default)().editorStylingMode || "outlined",
            text: "",
            todayButtonText: _message.default.format("dxCalendar-todayButtonText"),
            useHiddenSubmitElement: false,
            useMaskBehavior: false,
            validationError: null,
            validationErrors: null,
            validationMessageMode: "auto",
            validationMessagePosition: "auto",
            validationStatus: "valid",
            value: [null, null],
            valueChangeEvent: "change",
            onValueChanged: null,
            onOpened: null,
            onClosed: null
        })
    };
    _proto._defaultOptionsRules = function() {
        return _Widget.prototype._defaultOptionsRules.call(this).concat([{
            device: function() {
                var themeName = (0, _themes.current)();
                return (0, _themes.isMaterial)(themeName)
            },
            options: {
                stylingMode: (0, _config.default)().editorStylingMode || "filled",
                labelMode: "floating"
            }
        }])
    };
    _proto._createOpenAction = function() {
        this._openAction = this._createActionByOption("onOpened", {
            excludeValidators: ["disabled", "readOnly"]
        })
    };
    _proto._raiseOpenAction = function() {
        if (!this._openAction) {
            this._createOpenAction()
        }
        this._openAction()
    };
    _proto._createCloseAction = function() {
        this._closeAction = this._createActionByOption("onClosed", {
            excludeValidators: ["disabled", "readOnly"]
        })
    };
    _proto._raiseCloseAction = function() {
        if (!this._closeAction) {
            this._createCloseAction()
        }
        this._closeAction()
    };
    _proto._createValueChangeAction = function() {
        this._valueChangeAction = this._createActionByOption("onValueChanged", {
            excludeValidators: ["disabled", "readOnly"]
        })
    };
    _proto._raiseValueChangeAction = function(value, previousValue) {
        if (!this._valueChangeAction) {
            this._createValueChangeAction()
        }
        this._valueChangeAction(this._valueChangeArgs(value, previousValue))
    };
    _proto._valueChangeArgs = function(value, previousValue) {
        return {
            value: value,
            previousValue: previousValue,
            event: this._valueChangeEventInstance
        }
    };
    _proto._saveValueChangeEvent = function(e) {
        this._valueChangeEventInstance = e
    };
    _proto._initTemplates = function() {
        this._templateManager.addDefaultTemplates({
            dropDownButton: new _function_template.FunctionTemplate((function(options) {
                var $icon = (0, _renderer.default)("<div>").addClass(DROP_DOWN_EDITOR_BUTTON_ICON);
                (0, _renderer.default)(options.container).append($icon)
            }))
        });
        this.callBase()
    };
    _proto._getDefaultButtons = function() {
        return [{
            name: "clear",
            Ctor: _uiText_editor.default
        }, {
            name: "dropDown",
            Ctor: _ui3.default
        }]
    };
    _proto._initMarkup = function() {
        this.$element().addClass(DATERANGEBOX_CLASS).addClass("dx-texteditor").addClass("dx-datebox-date").addClass("dx-dropdowneditor");
        this._renderStylingMode();
        this._renderStartDateBox();
        this._renderSeparator();
        this._renderEndDateBox();
        this._renderButtonsContainer();
        _Widget.prototype._initMarkup.call(this)
    };
    _proto._getStylingModePrefix = function() {
        return "".concat(DATERANGEBOX_CLASS, "-")
    };
    _proto._renderStylingMode = function() {
        var _this = this;
        var optionValue = this.option("stylingMode");
        var prefix = this._getStylingModePrefix();
        var allowedStylingClasses = ALLOWED_STYLING_MODES.map((function(mode) {
            return prefix + mode
        }));
        allowedStylingClasses.forEach((function(className) {
            return _this.$element().removeClass(className)
        }));
        var stylingModeClass = prefix + optionValue;
        if (-1 === allowedStylingClasses.indexOf(stylingModeClass)) {
            var defaultOptionValue = this._getDefaultOptions().stylingMode;
            var platformOptionValue = this._convertRulesToOptions(this._defaultOptionsRules()).stylingMode;
            stylingModeClass = prefix + (platformOptionValue || defaultOptionValue)
        }
        this.$element().addClass(stylingModeClass)
    };
    _proto._renderStartDateBox = function() {
        this._$startDateBox = (0, _renderer.default)("<div>").addClass(START_DATEBOX_CLASS).appendTo(this.$element());
        this._startDateBox = this._createComponent(this._$startDateBox, _ui2.default, this._getStartDateBoxConfig())
    };
    _proto._renderEndDateBox = function() {
        this._$endDateBox = (0, _renderer.default)("<div>").addClass(END_DATEBOX_CLASS).appendTo(this.$element());
        this._endDateBox = this._createComponent(this._$endDateBox, _ui2.default, this._getEndDateBoxConfig())
    };
    _proto._renderSeparator = function() {
        var $icon = (0, _icon.getImageContainer)(SEPARATOR_ICON_NAME);
        this._$separator = (0, _renderer.default)("<div>").addClass(DATERANGEBOX_SEPARATOR_CLASS).appendTo(this.$element());
        $icon.appendTo(this._$separator)
    };
    _proto._renderButtonsContainer = function() {
        this._buttonCollection = new _index.default(this, this._getDefaultButtons());
        this._$beforeButtonsContainer = null;
        this._$afterButtonsContainer = null;
        var _this$option = this.option(),
            buttons = _this$option.buttons;
        this._$beforeButtonsContainer = this._buttonCollection.renderBeforeButtons(buttons, this.$element());
        this._$afterButtonsContainer = this._buttonCollection.renderAfterButtons(buttons, this.$element())
    };
    _proto._updateButtons = function(names) {
        this._buttonCollection.updateButtons(names)
    };
    _proto._openHandler = function() {
        this._toggleOpenState()
    };
    _proto._toggleOpenState = function() {
        this.getStartDateBox().focus();
        this.option("opened", !this.option("opened"))
    };
    _proto._clearValueHandler = function(e) {
        this.getEndDateBox()._clearValueHandler(e);
        this.getStartDateBox()._clearValueHandler(e)
    };
    _proto._isClearButtonVisible = function() {
        return this.option("showClearButton") && !this.option("readOnly")
    };
    _proto._focusInHandler = function(e) {
        _Widget.prototype._focusInHandler.call(this, e)
    };
    _proto._getDateBoxConfig = function() {
        var options = this.option();
        return {
            acceptCustomValue: options.acceptCustomValue,
            activeStateEnabled: false,
            applyValueMode: options.applyValueMode,
            dateOutOfRangeMessage: options.dateOutOfRangeMessage,
            dateSerializationFormat: options.dateSerializationFormat,
            displayFormat: options.displayFormat,
            elementAttr: options.elementAttr,
            focusStateEnabled: options.focusStateEnabled,
            hoverStateEnabled: false,
            invalidDateMessage: options.invalidDateMessage,
            isValid: options.isValid,
            labelMode: options.labelMode,
            max: options.max,
            maxLength: options.maxLength,
            min: options.min,
            openOnFieldClick: options.openOnFieldClick,
            pickerType: "calendar",
            readOnly: options.readOnly,
            rtlEnabled: options.rtlEnabled,
            spellcheck: options.spellcheck,
            stylingMode: "underlined",
            useMaskBehavior: options.useMaskBehavior,
            validationMessageMode: options.validationMessageMode,
            validationMessagePosition: options.validationMessagePosition,
            validationStatus: options.validationStatus,
            valueChangeEvent: options.valueChangeEvent,
            _dateRangeBoxInstance: this
        }
    };
    _proto._getStartDateBoxConfig = function() {
        var _this2 = this;
        var options = this.option();
        return _extends({}, this._getDateBoxConfig(), {
            applyButtonText: options.applyButtonText,
            calendarOptions: options.calendarOptions,
            cancelButtonText: options.cancelButtonText,
            disabledDates: options.disabledDates,
            dropDownOptions: options.dropDownOptions,
            onValueChanged: function(_ref) {
                var value = _ref.value;
                var newValue = [value, _this2.option("value")[1]];
                _this2.updateValue(newValue)
            },
            opened: options.opened,
            onOpened: function() {
                _this2.option("opened", true);
                _this2._raiseOpenAction()
            },
            onClosed: function() {
                _this2.option("opened", false);
                _this2._raiseCloseAction()
            },
            todayButtonText: options.todayButtonText,
            showClearButton: false,
            showDropDownButton: false,
            value: this.option("value")[0],
            label: options.startDateLabel,
            placeholder: options.startDatePlaceholder
        })
    };
    _proto._getEndDateBoxConfig = function() {
        var _this3 = this;
        var options = this.option();
        return _extends({}, this._getDateBoxConfig(), {
            dropDownOptions: {
                onShowing: function(e) {
                    e.cancel = true;
                    _this3.getStartDateBox().open()
                }
            },
            onValueChanged: function(_ref2) {
                var value = _ref2.value;
                var newValue = [_this3.option("value")[0], value];
                _this3.updateValue(newValue)
            },
            showClearButton: false,
            showDropDownButton: false,
            value: this.option("value")[1],
            label: options.endDateLabel,
            placeholder: options.endDatePlaceholder
        })
    };
    _proto._getDate = function(value) {
        return _date_serialization.default.deserializeDate(value)
    };
    _proto._isSameDates = function(date1, date2) {
        if (!date1 && !date2) {
            return true
        }
        return _date.default.sameDate(this._getDate(date1), this._getDate(date2))
    };
    _proto.updateValue = function(newValue) {
        var _newValue = _slicedToArray(newValue, 2),
            newStartDate = _newValue[0],
            newEndDate = _newValue[1];
        var _this$option2 = this.option("value"),
            _this$option3 = _slicedToArray(_this$option2, 2),
            oldStartDate = _this$option3[0],
            oldEndDate = _this$option3[1];
        if (!this._isSameDates(newStartDate, oldStartDate) || !this._isSameDates(newEndDate, oldEndDate)) {
            this.option("value", newValue)
        }
    };
    _proto._updateDateBoxesValue = function(newValue) {
        var startDateBox = this.getStartDateBox();
        var endDateBox = this.getEndDateBox();
        var _newValue2 = _slicedToArray(newValue, 2),
            newStartDate = _newValue2[0],
            newEndDate = _newValue2[1];
        var oldStartDate = startDateBox.option("value");
        var oldEndDate = endDateBox.option("value");
        if (!this._isSameDates(newStartDate, oldStartDate)) {
            startDateBox.option("value", newStartDate)
        }
        if (!this._isSameDates(newEndDate, oldEndDate)) {
            endDateBox.option("value", newEndDate)
        }
    };
    _proto._focusTarget = function() {
        return this.$element().find(".".concat(TEXTEDITOR_INPUT_CLASS))
    };
    _proto._focusEventTarget = function() {
        return this.element()
    };
    _proto._focusClassTarget = function() {
        return this.$element()
    };
    _proto._toggleFocusClass = function(isFocused, $element) {
        _Widget.prototype._toggleFocusClass.call(this, isFocused, this._focusClassTarget($element))
    };
    _proto._cleanButtonContainers = function() {
        var _this$_$beforeButtons, _this$_$afterButtonsC;
        null === (_this$_$beforeButtons = this._$beforeButtonsContainer) || void 0 === _this$_$beforeButtons ? void 0 : _this$_$beforeButtons.remove();
        null === (_this$_$afterButtonsC = this._$afterButtonsContainer) || void 0 === _this$_$afterButtonsC ? void 0 : _this$_$afterButtonsC.remove();
        this._buttonCollection.clean();
        this._$beforeButtonsContainer = null;
        this._$afterButtonsContainer = null
    };
    _proto._clean = function() {
        var _this$_$startDateBox, _this$_$endDateBox, _this$_$separator;
        this._cleanButtonContainers();
        null === (_this$_$startDateBox = this._$startDateBox) || void 0 === _this$_$startDateBox ? void 0 : _this$_$startDateBox.remove();
        null === (_this$_$endDateBox = this._$endDateBox) || void 0 === _this$_$endDateBox ? void 0 : _this$_$endDateBox.remove();
        null === (_this$_$separator = this._$separator) || void 0 === _this$_$separator ? void 0 : _this$_$separator.remove();
        _Widget.prototype._clean.call(this)
    };
    _proto._optionChanged = function(args) {
        var name = args.name,
            value = args.value,
            previousValue = args.previousValue;
        switch (name) {
            case "acceptCustomValue":
            case "applyButtonText":
            case "applyValueMode":
                break;
            case "buttons":
                this._cleanButtonContainers();
                this._renderButtonsContainer();
                break;
            case "calendarOptions":
            case "cancelButtonText":
            case "dateOutOfRangeMessage":
            case "disabledDates":
            case "displayFormat":
            case "dropDownOptions":
                break;
            case "dropDownButtonTemplate":
            case "showDropDownButton":
                this._updateButtons(["dropDown"]);
                break;
            case "showClearButton":
                this._updateButtons(["clear"]);
                break;
            case "endDate":
            case "invalidDateMessage":
            case "isValid":
                break;
            case "startDateLabel":
                this.getStartDateBox().option("label", value);
                break;
            case "endDateLabel":
                this.getEndDateBox().option("label", value);
                break;
            case "startDatePlaceholder":
                this.getStartDateBox().option("placeholder", value);
                break;
            case "endDatePlaceholder":
                this.getEndDateBox().option("placeholder", value);
                break;
            case "labelMode":
            case "maxLength":
                break;
            case "onValueChanged":
                this._createValueChangeAction();
                break;
            case "opened":
                this.getStartDateBox().option("opened", value);
                break;
            case "onOpened":
            case "onClosed":
                break;
            case "openOnFieldClick":
            case "readOnly":
            case "spellcheck":
            case "startDate":
                break;
            case "stylingMode":
                this._renderStylingMode();
                break;
            case "text":
            case "todayButtonText":
            case "useHiddenSubmitElement":
            case "useMaskBehavior":
            case "validationError":
            case "validationErrors":
            case "validationMessageMode":
            case "validationMessagePosition":
            case "validationStatus":
                break;
            case "value":
                this._raiseValueChangeAction(value, previousValue);
                this._saveValueChangeEvent(void 0);
                this._updateDateBoxesValue(value);
                break;
            case "valueChangeEvent":
                break;
            default:
                _Widget.prototype._optionChanged.call(this, args)
        }
    };
    _proto.getStartDateBox = function() {
        return this._startDateBox
    };
    _proto.getEndDateBox = function() {
        return this._endDateBox
    };
    _proto.getButton = function(name) {
        return this._buttonCollection.getButton(name)
    };
    _proto.open = function() {
        this.option("opened", true)
    };
    _proto.close = function() {
        this.option("opened", false)
    };
    _proto.content = function() {
        return this.getStartDateBox().content()
    };
    _proto.field = function() {
        return [(0, _element.getPublicElement)(this.getStartDateBox()._input()), (0, _element.getPublicElement)(this.getEndDateBox()._input())]
    };
    _proto.reset = function() {
        this.getEndDateBox().reset();
        this.getStartDateBox().reset()
    };
    return DateRangeBox
}(_ui.default);
(0, _component_registrator.default)("dxDateRangeBox", DateRangeBox);
var _default = DateRangeBox;
exports.default = _default;
module.exports = exports.default;
module.exports.default = exports.default;
