/**
* DevExtreme (ui/date_range_box.d.ts)
* Version: 23.1.1 (build 23114-0308)
* Build date: Mon Apr 24 2023
*
* Copyright (c) 2012 - 2023 Developer Express Inc. ALL RIGHTS RESERVED
* Read about DevExtreme licensing here: https://js.devexpress.com/Licensing/
*/
import {
  EventInfo,
  NativeEventInfo,
  InitializedEventInfo,
  ChangedOptionInfo,
} from '../events/index';

import {
  DropDownButtonTemplateDataModel,
} from './drop_down_editor/ui.drop_down_editor';

import { DateBoxBase, DateBoxBaseOptions } from './date_box';

import {
  ValueChangedInfo,
} from './editor/editor';

export type DateRangePickerType = 'calendar' | 'native';

export type ChangeEvent = NativeEventInfo<dxDateRangeBox>;

export type ClosedEvent = EventInfo<dxDateRangeBox>;

export type ContentReadyEvent = EventInfo<dxDateRangeBox>;

export type CopyEvent = NativeEventInfo<dxDateRangeBox, ClipboardEvent>;

export type CutEvent = NativeEventInfo<dxDateRangeBox, ClipboardEvent>;

export type DisposingEvent = EventInfo<dxDateRangeBox>;

export type EnterKeyEvent = NativeEventInfo<dxDateRangeBox, KeyboardEvent>;

export type FocusInEvent = NativeEventInfo<dxDateRangeBox, FocusEvent>;

export type FocusOutEvent = NativeEventInfo<dxDateRangeBox, FocusEvent>;

export type InitializedEvent = InitializedEventInfo<dxDateRangeBox>;

export type InputEvent = NativeEventInfo<dxDateRangeBox, UIEvent & { target: HTMLInputElement }>;

export type KeyDownEvent = NativeEventInfo<dxDateRangeBox, KeyboardEvent>;

export type KeyPressEvent = NativeEventInfo<dxDateRangeBox, KeyboardEvent>;

export type KeyUpEvent = NativeEventInfo<dxDateRangeBox, KeyboardEvent>;

export type OpenedEvent = EventInfo<dxDateRangeBox>;

export type OptionChangedEvent = EventInfo<dxDateRangeBox> & ChangedOptionInfo;

export type PasteEvent = NativeEventInfo<dxDateRangeBox, ClipboardEvent>;

export type ValueChangedEvent =
    NativeEventInfo<dxDateRangeBox, KeyboardEvent | MouseEvent | PointerEvent | Event>
    & ValueChangedInfo;

export type DropDownButtonTemplateData = DropDownButtonTemplateDataModel;

export type Properties = DateBoxBaseOptions<dxDateRangeBox> & {
    /**
     * 
     */
    endDate?: Date | number | string;
    /**
     * 
     */
    pickerType?: DateRangePickerType;
    /**
     * 
     */
    startDate?: Date | number | string;
    /**
     * 
     */
    value?: Array<Date | number | string>;
};

/**
 * 
 */
export default class dxDateRangeBox extends DateBoxBase<Properties> { }
